on readPrefsFile
  global gPrefsPath, gHomeDir, gWinVersion, gWelcomeState, gAudioState, gFanState, gOnlinePath, gOnlineChoice, gROMDrive
  if the machineType = 256 then
    set PrefsName to gHomeDir & "hawaii.ini"
  else
    alert("Serious error: this call to readPrefsFile should not happen on a Mac!")
    quit()
  end if
  set gReadObject to FileIO(mnew, "read", PrefsName)
  if not objectp(gReadObject) then
    if the machineType = 256 then
      alert("Cannot find HAWAII.INI." & RETURN & "Please run SETUP.EXE from the CD-ROM.")
      quit()
    else
      exit
    end if
  else
    set gPrefsPath to gReadObject(mReadFile)
    gReadObject(mdispose)
    set str to line 1 of gPrefsPath
    set gHomeDir to EMPTY
    repeat with C = 1 to the number of chars in str
      if char C of str = "=" then
        repeat with n = C + 1 to length(str)
          put char n of str after gHomeDir
        end repeat
        exit repeat
      end if
    end repeat
    set str to line 2 of gPrefsPath
    repeat with C = 1 to the number of chars in str
      if char C of str = "=" then
        set gROMDrive to char C + 1 of str
        exit repeat
      end if
    end repeat
    set str to line 3 of gPrefsPath
    set gOnlineChoice to EMPTY
    repeat with C = 1 to length(str)
      if char C of str = "=" then
        repeat with n = C + 1 to length(str)
          put char n of str after gOnlineChoice
        end repeat
        exit repeat
      end if
    end repeat
    set str to line 4 of gPrefsPath
    set WinV to EMPTY
    repeat with C = 1 to length(str)
      if char C of str = "=" then
        repeat with n = C + 1 to length(str)
          put char n of str after WinV
        end repeat
        exit repeat
      end if
    end repeat
    set gWinVersion to float(WinV)
    set str to line 5 of gPrefsPath
    set gWelcomeState to 0
    repeat with C = 1 to length(str)
      if char C of str = "=" then
        set gWelcomeState to integer(char C + 1 of str)
        exit repeat
      end if
    end repeat
    set str to line 6 of gPrefsPath
    set gAudioState to 0
    repeat with C = 1 to length(str)
      if char C of str = "=" then
        set gAudioState to integer(char C + 1 of str)
        exit repeat
      end if
    end repeat
    set str to line 7 of gPrefsPath
    set gFanState to 1
    repeat with C = 1 to length(str)
      if char C of str = "=" then
        set gFanState to integer(char C + 1 of str)
        exit repeat
      end if
    end repeat
    set str to line 8 of gPrefsPath
    set gOnlinePath to EMPTY
    repeat with C = 1 to length(str)
      if char C of str = "=" then
        repeat with n = C + 1 to length(str)
          put char n of str after gOnlinePath
        end repeat
        exit repeat
      end if
    end repeat
  end if
end

on writePrefsFile
  global gPrefsPath, gHomeDir, gROMDrive, gWinVersion, gWelcomeState, gAudioState, gFanState, gOnlinePath, gOnlineChoice
  if voidp(gPrefsPath) = 1 then
    if the machineType <> 256 then
      alert("Sorry, cannot find appropriate path to save preferences." & RETURN & RETURN & "Please quit and copy the Experience Hawaii to your hard drive!")
    else
      alert("Sorry, cannot find your preferences file." & RETURN & "Please run SetUp from the CD-ROM and then start Experience Hawaii from your hard drive")
    end if
    cursor(0)
    abort()
  end if
  if the machineType <> 256 then
    set PrefsName to gHomeDir & "Hawaii Prefs"
  else
    set PrefsName to gHomeDir & "hawaii.ini"
  end if
  set gWriteObject to FileIO(mnew, "write", PrefsName)
  if not objectp(gWriteObject) then
    alert("ERROR!" & RETURN & "Sorry, unable to save Hawaii.prefs.  & RETURN & If possible allocate more memory to the Experience Hawaii application! & RETURN &America Online should install correctly!")
    exit
  end if
  gWriteObject(mWriteString, "Home Directory=" & string(gHomeDir) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "CDROM Drive=" & string(gROMDrive) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "Online Choice=" & string(gOnlineChoice) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "Windows Version=" & string(gWinVersion) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "Welcome=" & string(gWelcomeState) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "Audio=" & string(gAudioState) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "Fan=" & string(gFanState) & RETURN & numToChar(10))
  gWriteObject(mWriteString, "Online Path=" & string(gOnlinePath) & RETURN & numToChar(10))
  gWriteObject(mdispose)
end
